=== debian/changelog ===
gitlab-shell (13.19.1-2) unstable; urgency=medium

  * Reupload to unstable
  * Update watch file standard to 4

 -- Pirate Praveen <praveen@debian.org>  Wed, 22 Sep 2021 03:50:53 +0530

gitlab-shell (13.19.1-1) experimental; urgency=medium

  * Team upload
  * New upstream version 13.19.1

 -- Sruthi Chandran <srud@debian.org>  Mon, 30 Aug 2021 23:32:37 +0530

gitlab-shell (13.18.1-1) unstable; urgency=medium

  * Reupload to unstable
  * New upstream version 13.18.1
  * Bump Standards-Version to 4.6.0 (no changes needed)
  * Bump debhelper compatibility level to 13

 -- Pirate Praveen <praveen@debian.org>  Sat, 28 Aug 2021 19:01:00 +0530

gitlab-shell (13.18.0-1) experimental; urgency=medium

  * New upstream version 13.18.0
  * Add golang-github-pires-go-proxyproto-dev as build dependency

 -- Pirate Praveen <praveen@debian.org>  Sat, 12 Jun 2021 11:56:18 +0530

gitlab-shell (13.17.0-2) experimental; urgency=medium

  * Fix patch that hardcoded gitlab-shell directory path

 -- Pirate Praveen <praveen@debian.org>  Wed, 10 Mar 2021 21:59:27 +0530

gitlab-shell (13.17.0-1) experimental; urgency=medium

  * New upstream version 13.17.0
  * Refresh patches
  * Update build dependencies

 -- Pirate Praveen <praveen@debian.org>  Wed, 10 Mar 2021 14:31:37 +0530

gitlab-shell (13.15.1-1) experimental; urgency=medium

  * New upstream version 13.15.1

 -- Pirate Praveen <praveen@debian.org>  Sun, 07 Mar 2021 19:21:07 +0530

gitlab-shell (13.14.1-1) experimental; urgency=medium

  * Add vendor as a component tarball
  * New upstream version 13.14.1
  * Bump Standards-Version to 4.5.1 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Fri, 19 Feb 2021 00:33:49 +0530
