## gitlab-shell 13.23.2+vendorupdate1

=== debian/changelog ===
gitlab-shell (13.23.2+vendorupdate1-1) experimental; urgency=medium

  * Use newer grpc from experimental
  * Use packaged version of golang-gitlab-gitlab-org-gitaly-dev
  * New upstream version 13.23.2+vendorupdate1

 -- Pirate Praveen <praveen@debian.org>  Fri, 06 May 2022 19:22:42 +0530

gitlab-shell (13.22.2-1) experimental; urgency=medium

  * New upstream version 13.22.2

 -- Pirate Praveen <praveen@debian.org>  Sat, 02 Apr 2022 12:32:21 +0530

gitlab-shell (13.22.1-2) experimental; urgency=medium

  * Update minimum version of golang-any (>= 2:1.17~)

 -- Pirate Praveen <praveen@debian.org>  Sun, 26 Dec 2021 15:09:32 +0530

gitlab-shell (13.22.1-1) experimental; urgency=medium

  * New upstream version 13.22.1
  * Update grpc protocol dependencies

 -- Pirate Praveen <praveen@debian.org>  Fri, 17 Dec 2021 12:20:44 +0530

gitlab-shell (13.21.1-1) experimental; urgency=medium

  * New upstream version 13.21.1

 -- Pirate Praveen <praveen@debian.org>  Thu, 11 Nov 2021 22:15:32 +0530
