=== debian/control ===
--- 
+++ 
@@ -6,15 +6,16 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-any,
+               golang-any (>= 2:1.17~),
                golang-golang-x-crypto-dev (>= 1:0.0~git20180513.94e3fad~),
                golang-golang-x-net-dev,
                golang-golang-x-text-dev,
                golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
                golang-gitaly-proto-dev,
                golang-github-sirupsen-logrus-dev (>= 1.0~),
-               golang-google-grpc-dev (>= 1.22~),
+               golang-google-grpc-dev (>= 1.38~),
                golang-google-genproto-dev,
+               golang-google-protobuf-dev,
                golang-goprotobuf-dev (>= 1.3~),
                golang-gopkg-yaml.v2-dev,
                golang-github-client9-reopen-dev,
@@ -25,10 +26,11 @@
                golang-github-otiai10-copy-dev,
                golang-github-pmezard-go-difflib-dev,
                golang-github-mattn-go-shellwords-dev,
-               golang-github-pires-go-proxyproto-dev,
+               golang-github-pires-go-proxyproto-dev (>= 0.6~),
                golang-github-prometheus-client-golang-dev (>= 1.9~),
                golang-github-sebest-xff-dev,
-               golang-gitlab-gitlab-org-labkit-dev (>= 1.3.0-3~)
+               golang-gitlab-gitlab-org-labkit-dev (>= 1.7~),
+               golang-gitlab-gitlab-org-gitaly-dev (>= 14.6~)
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/ruby-team/gitlab-shell
 Vcs-Git: https://salsa.debian.org/ruby-team/gitlab-shell.git
