## gitlab-shell 14.11.0

=== debian/changelog ===
gitlab-shell (14.11.0-2) experimental; urgency=medium

  * Team upload.
  * Update minimum version of yamux in runtime dependency

 -- Mohammed Bilal <mdbilal@disroot.org>  Sat, 20 Aug 2022 13:34:56 +0530

gitlab-shell (14.11.0-1) experimental; urgency=medium

  * New upstream version 14.11.0

 -- Pirate Praveen <praveen@debian.org>  Fri, 19 Aug 2022 18:52:32 +0530

gitlab-shell (14.7.4-1) experimental; urgency=medium

  * Update minimum version of golang-gitlab-gitlab-org-labkit-dev to (>= 1.16~)
  * New upstream version 14.7.4
  * Switch to golang-go (x/net is broken with gccgo)

 -- Pirate Praveen <praveen@debian.org>  Sat, 30 Jul 2022 13:00:58 +0200

gitlab-shell (14.3.1-1) experimental; urgency=medium

  * New upstream version 14.3.1

 -- Pirate Praveen <praveen@debian.org>  Sat, 16 Jul 2022 23:39:02 +0200

gitlab-shell (13.25.2-1) experimental; urgency=medium

  * New upstream version 13.25.2
  * Bump Standards-Version to 4.6.1 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Mon, 27 Jun 2022 20:34:50 +0530

gitlab-shell (13.24.0+debian2-1) experimental; urgency=medium

  * New upstream version 13.24.0+debian2
  * Drop vendor extra tarball

 -- Pirate Praveen <praveen@debian.org>  Wed, 11 May 2022 12:23:17 +0530

gitlab-shell (13.24.0+debian1-1) experimental; urgency=medium

  [ Pirate Praveen ]
  * New upstream version 13.24.0

  [ Nilesh Patra ]
  * Update embedded version of gitaly to v14.9.0

  [ Pirate Praveen ]
  * New upstream version 13.24.0+debian1 (remove embedded gitaly, it was
    included by mistake)

 -- Pirate Praveen <praveen@debian.org>  Sun, 08 May 2022 23:54:16 +0530
