=== debian/control ===
--- 
+++ 
@@ -6,7 +6,9 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-any (>= 2:1.17~),
+# See #1016217 (gccgo and x/net don't work well together right now)
+#               golang-any (>= 2:1.17~),
+               golang-go (>= 2:1.17~),
                golang-golang-x-crypto-dev (>= 1:0.0~git20180513.94e3fad~),
                golang-golang-x-net-dev,
                golang-golang-x-text-dev,
@@ -20,8 +22,9 @@
                golang-gopkg-yaml.v2-dev,
                golang-github-client9-reopen-dev,
                golang-github-davecgh-go-spew-dev,
+               golang-github-golang-jwt-jwt-dev,
                golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
-               golang-github-hashicorp-yamux-dev,
+               golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
                golang-github-opentracing-opentracing-go-dev,
                golang-github-otiai10-copy-dev,
                golang-github-pmezard-go-difflib-dev,
@@ -29,9 +32,9 @@
                golang-github-pires-go-proxyproto-dev (>= 0.6~),
                golang-github-prometheus-client-golang-dev (>= 1.9~),
                golang-github-sebest-xff-dev,
-               golang-gitlab-gitlab-org-labkit-dev (>= 1.7~),
+               golang-gitlab-gitlab-org-labkit-dev (>= 1.16~),
                golang-gitlab-gitlab-org-gitaly-dev (>= 14.6~)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/ruby-team/gitlab-shell
 Vcs-Git: https://salsa.debian.org/ruby-team/gitlab-shell.git
 Homepage: https://gitlab.com/gitlab-org/gitlab-shell/
